## libocxl 1.1.0

=== Makefile ===
srcdir = $(PWD)
include Makefile.vars

OBJS = obj/afu.o obj/internal.o obj/irq.o obj/mmio.o obj/setup.o
TEST_OBJS = testobj/afu.o testobj/internal.o testobj/irq.o testobj/mmio.o testobj/setup.o
CFLAGS += -I src/include -I kernel/include -fPIC -D_FILE_OFFSET_BITS=64

VERS_LIB = $(VERSION_MAJOR).$(VERSION_MINOR)
LIBNAME   = libocxl.so.$(VERS_LIB)
LIBSONAME = libocxl.so.$(VERSION_MAJOR)
SONAMEOPT = -Wl,-soname,$(LIBSONAME)

DOCDIR = docs

all: check_ocxl_header obj/$(LIBSONAME) obj/libocxl.so obj/libocxl.a sampleobj/memcpy

HAS_WGET = $(shell /bin/which wget > /dev/null 2>&1 && echo y || echo n)
HAS_CURL = $(shell /bin/which curl > /dev/null 2>&1 && echo y || echo n)

# Update this to test a single feature from the most recent header we require:
CHECK_OCXL_HEADER_IS_UP_TO_DATE = $(shell /bin/echo -e \\\#include $(1)\\\nvoid test\(struct ocxl_ioctl_features test\)\; | \
	$(CC) $(CFLAGS) -Werror -x c -S -o /dev/null - > /dev/null 2>&1 && echo y || echo n)

check_ocxl_header:
ifeq ($(call CHECK_OCXL_HEADER_IS_UP_TO_DATE,'<misc/ocxl.h>'),n)
	mkdir -p kernel/include/misc
ifeq (${HAS_WGET},y)
	$(call Q,WGET kernel/include/misc/ocxl.h, wget -O kernel/include/misc/ocxl.h -q http://git.kernel.org/cgit/linux/kernel/git/torvalds/linux.git/plain/include/uapi/misc/ocxl.h)
else ifeq (${HAS_CURL},y)
	$(call Q,CURL kernel/include/misc/ocxl.h, curl -o kernel/include/misc/ocxl.h -s http://git.kernel.org/cgit/linux/kernel/git/torvalds/linux.git/plain/include/uapi/misc/ocxl.h)
else
	$(error 'ocxl.h is non-existant or out of date, Download from http://git.kernel.org/cgit/linux/kernel/git/torvalds/linux.git/plain/include/uapi/misc/ocxl.h and place in ${PWD}/kernel/include/misc/ocxl.h')
endif
endif

src/libocxl_info.h: version.pl
	VERSION_MAJOR=${VERSION_MAJOR} VERSION_MINOR=${VERSION_MINOR} \
	VERSION_PATCH=${VERSION_PATCH} CC="${CC}" CFLAGS="${CFLAGS}" \
	./version.pl > src/libocxl_info.h

obj:
	mkdir obj

obj/libocxl.so: obj/$(LIBNAME)
	ln -sf $(LIBNAME) obj/libocxl.so

obj/$(LIBSONAME): obj/$(LIBNAME)
	ln -sf $(LIBNAME) obj/$(LIBSONAME)

obj/$(LIBNAME): $(OBJS) symver.map
	$(call Q,CC, $(CC) $(CFLAGS) $(LDFLAGS) -shared $(OBJS) -o obj/$(LIBNAME), obj/$(LIBNAME)) -Wl,--version-script symver.map $(SONAMEOPT)

obj/libocxl.a: $(OBJS)
	$(call Q,AR, $(AR) rcs obj/libocxl.a $(OBJS), obj/libocxl.a)

sampleobj/memcpy: sampleobj/memcpy.o-memcpy
	$(call Q,CC, $(CC) $(CFLAGS) $(LDFLAGS) -o sampleobj/memcpy sampleobj/memcpy.o-memcpy obj/libocxl.a, sampleobj/memcpy)

testobj:
	mkdir testobj

sampleobj:
	mkdir sampleobj

testobj/libocxl.a: $(TEST_OBJS)
	$(call Q,AR, $(AR) rcs testobj/libocxl-temp.a $(TEST_OBJS), testobj/libocxl-temp.a)
	$(call Q,STATIC_SYMS, $(NM) testobj/libocxl-temp.a | grep ' t ' | grep -v __ | cut -d ' ' -f 3 > testobj/static-syms)
	$(call Q,STATIC_PROTOTYPES, perl -n static-prototypes.pl src/*.c >testobj/static.h)
	$(call Q,OBJCOPY, $(OBJCOPY) --globalize-symbols=testobj/static-syms testobj/libocxl-temp.a testobj/libocxl.a, obj/libocxl.a)

testobj/unittests: testobj/unittests.o-test testobj/virtocxl.o-test
	$(call Q,CC, $(CC) $(CFLAGS) $(LDFLAGS) -o testobj/unittests testobj/unittests.o-test testobj/virtocxl.o-test testobj/libocxl.a -lfuse -lpthread, testobj/unittests)

test: check_ocxl_header testobj/unittests
	sudo testobj/unittests

valgrind: testobj/unittests
	sudo valgrind testobj/unittests

include Makefile.rules

cppcheck:
	cppcheck --enable=all -j 4 -q  src/*.c src/include/libocxl.h

cppcheck-xml:
	cppcheck --enable=all -j 4 -q  src/*.c src/include/libocxl.h --xml-version=2 2>cppcheck.xml

precommit: clean all docs cppcheck
	astyle --style=linux --indent=tab=8 --max-code-length=120 src/*.c src/*.h src/include/*.h samples/*/*.c
	$(call Q, SYMVER-CHECK, nm obj/$(LIBNAME) | grep ' t ocxl' && (echo "Symbols are missing from symver.map" && exit 1) || true)

docs:
	rm -rf $(DOCDIR)
	$(call Q,DOCS-MAN, doxygen Doxyfile-man,)
	cd docs/man/man3 && \
		ls | grep -vi ocxl | xargs rm
	$(call Q,DOCS-HTML, doxygen Doxyfile-html,)

clean:
	rm -rf obj testobj sampleobj docs src/libocxl_info.h

install: all docs
	mkdir -p $(DESTDIR)$(libdir)
	mkdir -p $(DESTDIR)$(includedir)
	mkdir -p $(DESTDIR)$(mandir)/man3
	mkdir -p $(DESTDIR)$(docdir)/libocxl/search
	$(INSTALL) -m 0755 obj/$(LIBNAME) $(DESTDIR)$(libdir)/
	ln -s $(LIBNAME) $(DESTDIR)$(libdir)/$(LIBSONAME)
	ln -s $(LIBNAME) $(DESTDIR)$(libdir)/libocxl.so
	$(INSTALL) -m 0644 src/include/libocxl.h  $(DESTDIR)$(includedir)/
	$(INSTALL) -m 0644 -D docs/man/man3/* $(DESTDIR)$(mandir)/man3
	$(INSTALL) -m 0644 -D docs/html/*.* $(DESTDIR)$(docdir)/libocxl
	$(INSTALL) -m 0644 -D docs/html/search/* $(DESTDIR)$(docdir)/libocxl/search

.PHONY: clean all install docs precommit cppcheck cppcheck-xml check_ocxl_header

## libocxl 1.0.0

=== debian/changelog ===
libocxl (1.0.0-1~ubuntu18.04.0) bionic; urgency=medium

  * Backport libocxl to bionic to enable userspace support for the
    opencapi harware cards. LP: #1771813

 -- Dimitri John Ledkov 🌈 <xnox@ubuntu.com>  Thu, 14 Jun 2018 12:33:33 +0100

libocxl (1.0.0-1) unstable; urgency=medium

  * Initial release (Closes: #897058)

 -- Frédéric Bonnard <frediz@debian.org>  Thu, 03 May 2018 13:44:06 +0200

=== debian/control ===
Source: libocxl
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Frédéric Bonnard <frediz@debian.org>
Build-Depends: debhelper (>= 11), doxygen
Standards-Version: 4.1.4
Section: libs
Homepage: https://github.com/OpenCAPI/libocxl
Vcs-Git: https://salsa.debian.org/debian/libocxl.git
Vcs-Browser: https://salsa.debian.org/debian/libocxl

Package: libocxl-dev
Section: libdevel
Architecture: ppc64el
Multi-Arch: same
Depends: libocxl1 (= ${binary:Version}), ${misc:Depends}
Suggests: libocxl-doc (= ${binary:Version})
Description: Development files for accessing OpenCAPI devices
 LibOCXL provides an access library which allows the user to implement a
 userspace driver for an OpenCAPI accelerator.
 .
 This package contains the development files.

Package: libocxl-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: libocxl-dev (= ${binary:Version})
Description: Documentation files for development with libocxl
 LibOCXL provides an access library which allows the user to implement a
 userspace driver for an OpenCAPI accelerator.
 .
 This package contains the documentation files.

Package: libocxl1
Architecture: ppc64el
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Runtime library for accessing OpenCAPI devices
 LibOCXL provides an access library which allows the user to implement a
 userspace driver for an OpenCAPI accelerator.
 .
 This package contains the runtime shared library.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- V=1

override_dh_auto_test:
	# High possibility of locking the machine at the moment

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/libocxl-$1\.tar\.gz/,uversionmangle=s/-beta/~beta/ \
  https://github.com/opencapi/libocxl/tags .*/v?(\d\S*)\.tar\.gz

## libocxl 1.1.0

=== debian/changelog ===
libocxl (1.1.0-1) unstable; urgency=medium

  * Fix d/gbp.conf
  * Update symbol file for 1.1.0
  * Update copyright information
  * Fix debhelper compatibility level
  * Bump Standards-Version

 -- Frédéric Bonnard <frediz@debian.org>  Tue, 11 Sep 2018 12:38:41 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: libocxl
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Frédéric Bonnard <frediz@debian.org>
-Build-Depends: debhelper (>= 11), doxygen
-Standards-Version: 4.1.4
+Maintainer: Frédéric Bonnard <frediz@debian.org>
+Build-Depends: debhelper (>= 11~), doxygen
+Standards-Version: 4.2.1
 Section: libs
 Homepage: https://github.com/OpenCAPI/libocxl
 Vcs-Git: https://salsa.debian.org/debian/libocxl.git

## libocxl 1.2.1

=== debian/changelog ===
libocxl (1.2.1-3) unstable; urgency=medium

  * Fix build of any

 -- Frédéric Bonnard <frediz@debian.org>  Fri, 26 Nov 2021 11:52:07 +0100

libocxl (1.2.1-2) unstable; urgency=medium

  * Fix indep build for all (Closes: #997052)

 -- Frédéric Bonnard <frediz@debian.org>  Tue, 26 Oct 2021 14:02:37 +0200

libocxl (1.2.1-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Frédéric Bonnard ]
  * Update to new upstream version 1.2.1.
  * Add Build-Depends-Package field to symbol file
  * Increase compatibility level to the recommended one
  * Add Rules-Requires-Root field to d/control
  * Update d/watch format
  * Rewrite to pick files directly from install dir
  * Disable file path fixing in the build
  * Update d/copyright info
  * Bump Standards-Version to 4.6.0.1

 -- Frédéric Bonnard <frediz@debian.org>  Thu, 21 Oct 2021 17:08:43 +0200

libocxl (1.1.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS. (Closes: #963364)
    - Use local header file.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 16 Jul 2020 22:37:44 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,10 @@
 Source: libocxl
 Priority: optional
 Maintainer: Frédéric Bonnard <frediz@debian.org>
-Build-Depends: debhelper (>= 11~), doxygen
-Standards-Version: 4.2.1
+Build-Depends: debhelper-compat (= 13), doxygen
+Build-Depends-Indep: doxygen
+Standards-Version: 4.6.0.1
+Rules-Requires-Root: no
 Section: libs
 Homepage: https://github.com/OpenCAPI/libocxl
 Vcs-Git: https://salsa.debian.org/debian/libocxl.git

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=-fixfilepath,-fixdebugpath

%:
	dh $@

override_dh_auto_build-arch:
	dh_auto_build -- V=1

override_dh_auto_build-indep:
	dh_auto_build -- docs

override_dh_auto_test:
	# High possibility of locking the machine at the moment

override_dh_auto_install-arch:
	dh_auto_install -- PREFIX=/usr libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
	rm -fr $(CURDIR)/debian/tmp/usr/share/doc/libocxl

override_dh_auto_install-indep:
	mkdir -p $(CURDIR)/debian/tmp/usr/share/doc/libocxl && \
	cp -a docs/html $(CURDIR)/debian/tmp/usr/share/doc/libocxl/

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/opencapi/libocxl/tags \
  (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
